<script setup lang="ts">
import { computed, onMounted, reactive } from "vue";
import type { BucketOut } from "@/client";
import { useRouter } from "vue-router";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import CreateBucketModal from "@/components/object-storage/modals/CreateBucketModal.vue";
import DeleteModal from "@/components/modals/DeleteModal.vue";
import BucketListItem from "@/components/object-storage/BucketListItem.vue";
import { useBucketStore } from "@/stores/buckets";
import { Modal, Tooltip } from "bootstrap";
import { useAuthStore } from "@/stores/users";

const router = useRouter();
const bucketRepository = useBucketStore();
const authStore = useAuthStore();

const props = defineProps<{
  bucketName?: string;
}>();

const bucketsState = reactive<{
  loading: boolean;
  filterString: string;
  potentialDeleteBucketName: string;
}>({
  filterString: "",
  potentialDeleteBucketName: "",
  loading: true,
});
let deleteModal: Modal | null = null;
let refreshTimeout: NodeJS.Timeout | undefined = undefined;

function fetchBuckets() {
  bucketRepository.fetchOwnPermissions();
  bucketRepository
    .fetchOwnBuckets(() => {
      bucketsState.loading = false;
    })
    .then((buckets) => {
      buckets
        .filter((bucket) => bucket.owner_id === authStore.currentUID)
        .map((bucket) => bucketRepository.fetchBucketPermissions(bucket.name));
    });
}

const filteredBuckets = computed<BucketOut[]>(() => {
  return bucketsState.filterString.length > 0
    ? bucketRepository.buckets.filter((bucket) =>
        bucket.name.includes(bucketsState.filterString),
      )
    : bucketRepository.buckets;
});

function deleteBucket(bucketName: string) {
  bucketsState.potentialDeleteBucketName = bucketName;
  deleteModal?.show();
}

function confirmedDeleteBucket(bucketName: string) {
  bucketRepository.deleteBucket(bucketName).then(() => {
    router.push({ name: "buckets" });
  });
}

function refreshBuckets() {
  clearTimeout(refreshTimeout);
  refreshTimeout = setTimeout(() => {
    fetchBuckets();
  }, 500);
}

onMounted(() => {
  deleteModal = Modal.getOrCreateInstance("#delete-bucket-modal");
  fetchBuckets();
  new Tooltip("#refreshBucketButton");
  new Tooltip("#createBucketButton");
});
</script>

<template>
  <DeleteModal
    modalId="delete-bucket-modal"
    :object-name-delete="bucketsState.potentialDeleteBucketName"
    :back-modal-id="undefined"
    @confirm-delete="
      confirmedDeleteBucket(bucketsState.potentialDeleteBucketName)
    "
  />
  <CreateBucketModal modalId="create-bucket-modal" />
  <div class="row border-bottom">
    <h2 class="mb-2">My Data Buckets</h2>
  </div>
  <div class="row mt-4">
    <div class="col-3">
      <div class="d-flex justify-content-between">
        <button
          type="button"
          id="refreshBucketButton"
          class="btn btn-light border shadow-sm"
          data-bs-title="Refresh Data Buckets"
          data-bs-toggle="tooltip"
          @click="refreshBuckets"
        >
          <font-awesome-icon
            icon="fa-solid fa-arrow-rotate-right"
            class="fs-5"
          />
          <span class="visually-hidden">Refresh Data Buckets</span>
        </button>
        <button
          id="createBucketButton"
          type="button"
          class="btn btn-light border shadow-sm"
          data-bs-toggle="modal"
          data-bs-title="Create New Data Bucket"
          data-bs-target="#create-bucket-modal"
        >
          <font-awesome-icon icon="fa-solid fa-plus" class="fs-5" />
          <span class="visually-hidden">Create New Data Bucket</span>
        </button>
      </div>
      <div class="input-group mt-2 rounded shadow-sm">
        <span class="input-group-text" id="buckets-search-wrapping"
          ><font-awesome-icon icon="fa-solid fa-magnifying-glass"
        /></span>
        <input
          id="filterBucketNameInput"
          type="text"
          class="form-control"
          placeholder="Search Buckets"
          aria-label="Search Buckets"
          aria-describedby="buckets-search-wrapping"
          v-model.trim="bucketsState.filterString"
        />
      </div>

      <div class="list-group mt-3">
        <div v-if="!bucketsState.loading">
          <div v-if="filteredBuckets.length > 0">
            <bucket-list-item
              v-for="bucket in filteredBuckets"
              :key="bucket.name"
              :active="props.bucketName === bucket.name"
              :deletable="true"
              :bucket="bucket"
              :loading="false"
              @delete-bucket="deleteBucket"
            />
          </div>
          <div v-else class="text-center fs-2 mt-5">
            <font-awesome-icon
              icon="fa-solid fa-magnifying-glass"
              class="mb-2 fs-0"
              style="color: var(--bs-secondary)"
            />
            <br />
            Could not find any Buckets
          </div>
        </div>
        <div v-else>
          <bucket-list-item
            v-for="n in 5"
            :key="n"
            :active="false"
            loading
            :deletable="false"
            :bucket="{
              name: '',
              description: '',
              created_at: 0,
              owner_id: '',
              public: false,
            }"
          ></bucket-list-item>
        </div>
      </div>
    </div>
    <div class="col-9">
      <router-view></router-view>
      <div
        v-if="router.currentRoute.value.name === 'buckets'"
        class="text-center mt-5"
      >
        <font-awesome-icon
          icon="fa-solid fa-hand-pointer"
          class="mb-5"
          style="color: var(--bs-secondary); font-size: 5em"
        />
        <p class="fs-2">Click on a bucket to browse its content</p>
      </div>
    </div>
  </div>
</template>

<style scoped></style>
